﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;
using System.Diagnostics;
using System.IO;
using Infragistics.Themes;

namespace DataGridExportToExcelStylesColumns
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            //ThemeManager.ApplicationTheme = new RoyalLightTheme();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.CellExporting += new EventHandler<CellExportingEventArgs>(exporter_CellExporting);

            string fileName = "xamDataGrid1.xlsx";

            if (File.Exists(fileName))
            {
                File.Delete(fileName);
            }

            exporter.Export(this.xamDataGrid1, fileName, WorkbookFormat.Excel2007);
            Process.Start("xamDataGrid1.xlsx");

        }

        void exporter_CellExporting (object sender, CellExportingEventArgs e)
        {


            var formatSetter = e.Field.Settings.EditorStyle.Setters.OfType<Setter>().FirstOrDefault(s => s.Property.Name == "Format");
            if (formatSetter != null)
            {
                if (e.Field.Settings.EditorStyle.Setters.OfType<Setter>().FirstOrDefault(setter => setter.Property.Name == "Format").Value.ToString() == "N")
                {
                    e.FormatSettings.FormatString = "#,##0.00";
                    e.FormatSettings.FontColor = Colors.Red;
                }
                else
                {
                    e.FormatSettings.FormatString = formatSetter.Value.ToString();
                    e.FormatSettings.FontColor = Colors.Yellow;
                }
            }

            //FormatSettings cellFormatSettings = new FormatSettings
            //{
            //    FillPattern = FillPatternStyle.Solid,
            //    FillPatternForegroundColor = Colors.Green
            //};
            //DataPresenterExcelExporter.SetExcelCellFormatSettings(this.xamDataGrid1.FieldSettings, cellFormatSettings);


            //FormatSettings labelFormatSettings = new FormatSettings
            //{
            //    FontColor = Colors.Pink,
            //    FontWeight = FontWeights.Bold
            //};
            //DataPresenterExcelExporter.SetExcelLabelFormatSettings(this.xamDataGrid1.FieldSettings, labelFormatSettings);
        }
    }
}